﻿function ConfigurationViewModel()
{
    var self = this;
    self.configuration = ko.observable(new Configuration());
    self.serialInterfaces = ko.observableArray();
    self.isBusy = ko.observable(false);

    self.getConfiguration = function ()
    {
        self.isBusy(true);
        $.ajax(
        {
            url: "/api/configuration",
            dataType: "json",
            success: function (data)
            {
                self.configuration(CreateConfigurationFromJsonData(data));
            },
            complete: function (x, s) { self.isBusy(false); }
        });
    };

    self.getSerialInterfaces = function ()
    {
        self.isBusy(true);
        $.ajax(
        {
            url: "/api/serialinterfaces",
            dataType: "json",
            success: function (data)
            {
                self.serialInterfaces(data);
            },
            complete: function (x, s) { self.isBusy(false); }
        });
    };

    self.saveConfiguration = function ()
    {
        self.isBusy(true);
        var data = JSON.stringify(self.configuration());
        console.log(data);
        console.log(self.configuration());

        $.ajax(
        {
            type: "POST",
            url: "/api/configuration",
            data: ko.toJSON(self.configuration()),
            success: function(data) 
            {
                alert("The configuration has been changed, please restart Lovon");
            },
            error: function(xhr, status, error)
            {
                alert("Failed to save the configuration\n" + status + "\n" + error);
            },
            complete: function (x, s) { self.isBusy(false); }
        });
    };
}