﻿

function IncomingEMailDetailsViewModel()
{
    var self = this;
    self.incomingEMailId = ko.observable(0);
    self.incomingEMail = ko.observable(new IncomingEMail());
    self.deliveryAttempts = ko.observableArray();
    self.incomingEMailBody = ko.observable("");
    self.isBusy = ko.observable(false);

    self.getDetails = function ()
    {
        self.isBusy(true);
        self.deliveryAttempts.removeAll();

        var url = "/api/email2sms/details?id=" + self.incomingEMailId();
        $.ajax(
        {
            url: url,
            dataType: "json",
            success: function (data) {
                var eMail = CreateIncomingEMailFromJsonData(data.EMail[0]);
                self.incomingEMail(eMail);

                for (var i = 0; i < data.DeliveryAttempts.length; i++) {
                    var attempt = CreateDeliveryAttemptFromJsonData(data.DeliveryAttempts[i]);
                    self.deliveryAttempts.push(attempt);
                }
            },
            complete: function (x, s) { self.isBusy(false); }
        });
    };

    self.getBody = function ()
    {
        self.isBusy(true);

        url = "/api/email2sms/body?id=" + self.incomingEMailId();
        $.ajax(
        {
            url: url,
            dataType: "json",
            success: function (data) {
                self.incomingEMailBody(data.Body);
            },
            complete: function (x, s) { self.isBusy(false); }
        });
    };

    self.resubmitForDelivery = function ()
    {
        self.isBusy(true);
        var data = {}
        data.id = self.incomingEMailId();
        data.action = "resubmitfordelivery";

        $.ajax({
            type: "POST",
            url: '/api/email2sms/action',
            data: JSON.stringify(data),
            success: function (data) {
                self.getDetails();
            },
            error: function (xhr, status, error) {
                alert('Failed to resubmit the message\n' + status);
            },
            complete: function (x, s) { self.isBusy(false); }
        });
    };
}