﻿function IncomingSmsDetailsViewModel()
{
    var self = this;
    self.incomingSmsId = ko.observable(0);
    self.incomingSms = ko.observable(new IncomingSms());
    self.deliveryAttempts = ko.observableArray();
    self.isBusy = ko.observable(false);

    self.getDetails = function()
    {
        self.isBusy(true);
        self.deliveryAttempts.removeAll();
        
        var url = "/api/sms2email/details?id=" + self.incomingSmsId();
        $.ajax(
        {
            url: url,
            dataType: "json",
            success: function (data)
            {
                var sms = CreateIncomingSmsFromJsonData(data.Sms[0]);
                self.incomingSms(sms);

                for (var i = 0; i < data.DeliveryAttempts.length; i++)
                {
                    var attempt = CreateDeliveryAttemptFromJsonData(data.DeliveryAttempts[i]);
                    self.deliveryAttempts.push(attempt);
                }
            },
            complete: function (x, s) { self.isBusy(false); }
        });
    };

    self.resubmitForDelivery = function () {
        self.isBusy(true)
        var data = {}
        data.id = self.incomingSmsId();
        data.action = "resubmitfordelivery";

        $.ajax({
            type: "POST",
            url: '/api/sms2email/action',
            data: JSON.stringify(data),
            success: function (data) {
                self.getDetails();
            },
            error: function (xhr, status, error) {
                alert('Failed to resubmit the message\n' + status);
            },
            complete: function (x, s) { self.isBusy(false); }
        });
    };
};